' ASCII datatype example
'REM $include datatypes.bh
'REM $include intuition.bh
'REM $include graphics.bh
'REM $include utility.bc
'REM $include exec.bh
'REM $include datatypes/textclass.bc
'REM $include datatypes/datatypesclass.bc

DEFINT a-z
LIBRARY OPEN "intuition.library",39
LIBRARY OPEN "graphics.library",39
LIBRARY OPEN "datatypes.library",39
LIBRARY OPEN "exec.library",39
LIBRARY OPEN "utility.library",39

SUB InitTextAttr(T(1),FontName$,BYVAL Height,BYVAL style,BYVAL flags)
POKEL VARPTR(T(0))+ta_Name%,SADD(FontName$+CHR$(0))
t(ta_YSize\2)=Height
POKEB VARPTR(T(0))+ta_Style,style
POKEB VARPTR(T(0))+ta_Flags,flags
END SUB
DIM tags&(40)
	filename$=COMMAND$
	IF LEN(filename$)=0 THEN
		PRINT "needs a filename": STOP
	END IF
	ShowTextFile filename$

SUB ShowTextFile(BYVAL filename$)
STATIC imsg&,tf&,scr&,win&,buffer&,filelength&,GfxBase&,junk&
STATIC buffer&,filelength&
SHARED o&
SHARED tags&(1)
STATIC ta(1)
DIM ta(TextAttr_sizeof\2)
' we can't read the data we want to display into an ordinary BASIC variable
' because when we pass the buffer to the datatype, we lose ownership of it
' and when we dispose of the data type object it will try to free it

	OPEN filename$ FOR INPUT AS #1
	
	filelength&=LOF(1)
	buffer& = AllocVec&(filelength& + 1, MEMF_CLEAR&)
	IF buffer& THEN
		BLOAD #1,buffer&,filelength&
		scr&=LockPubScreen&(0)
		IF scr& THEN
			GfxBase& =LIBRARY("graphics.library")
			tf&=PEEKL(GfxBase&+GfxBaseDefaultFont)
			InitTextAttr ta(),PEEK$(PEEKL(tf&+tf_message+mn_node+ln_name)),PEEKW(tf&+tf_Ysize),PEEKB(tf&+tf_Style),PEEKB(tf&+tf_Flags)
			TAGLIST VARPTR(tags&(0)), _
				 GA_Left&, PEEKB(scr&+WBorLeft), _
				 GA_Top&, PEEKB(scr&+BarHeight) + 1, _ 
				 GA_Width&, 300, _
				 GA_Height&, 300, _
				 GA_Immediate&, TRUE&, _
				 GA_RelVerify&, TRUE&, _
				 ICA_TARGET&, ICTARGET_IDCMP&, _
				 DTA_SourceType&, DTST_RAM&, _
				 DTA_GroupID&, GID_TEXT&, _
				 DTA_TextAttr&, VARPTR(ta(0)), _
				 TDTA_Buffer&, buffer&, _
				 TDTA_BufferLen&, filelength&, _
				 TDTA_WordWrap&, TRUE&, _
				 TAG_DONE&

			o& = NewDTObjectA(SADD("ascii.test"+CHR$(0)),VARPTR(tags&(0)))
			IF o& THEN
				TAGLIST VARPTR(tags&(0)), _
					WA_InnerWidth&, 300&, _
					WA_InnerHeight&, 300&, _
					WA_Title&, SADD(filename$+CHR$(0)), _
					WA_DragBar&, TRUE&, _
					WA_DepthGadget&, TRUE&, _
					WA_CloseGadget&, TRUE&, _
					WA_AutoAdjust&, TRUE&, _
					WA_SimpleRefresh&, TRUE&, _
					WA_IDCMP&, IDCMP_IDCMPUPDATE&+ IDCMP_CLOSEWINDOW&+ IDCMP_VANILLAKEY&, _
					TAG_DONE&
				win&= OpenWindowTagList&(0,VARPTR(tags&(0)))
				IF win& THEN
					junk& = AddDTObject&(win&, NULL&, o&, -1)
					RefreshDTObjectA o&, win&, NULL&, NULL&
					HandleEvents win&
					junk& = RemoveDTObject&(win&, o&)
					CloseWindow win&
				ELSE
				    PRINT "couldn't open window to display object in."
				END IF
				DisposeDTObject o&
				' Once you send the buffer to the object, it belongs to it.
				buffer& = 0
		    ELSE
				PRINT "couldn't create text object"
			END IF
			UnlockPubScreen 0, scr&
		END IF
		FreeVec buffer&
	ELSE
		PRINT "Can't allocate memory for file"
	END IF
END SUB

SUB HandleEvents(BYVAL win&)
STATIC junk&,imsg&,t&,cl&
SHARED o&
 ' Wait for the user to click */
'$event off
DO 
	junk&=	WaitPort(PEEKL(win&+UserPort))
	DO
		 imsg& =GetMsg(PEEKL(win&+UserPort))
		 IF imsg& THEN
		 	cl&=PEEKL(imsg&+Class)
		 	SELECT CASE cl&
		 	CASE IDCMP_CLOSEWINDOW&
			 	PRINT "closing window"
			 	ReplyMsg imsg& 
	 			EXIT SUB
			CASE IDCMP_IDCMPUPDATE&
				t&=PEEKL(imsg&+IAddress)
				IF FindTagItem&(DTA_Sync&, t&) THEN
					RefreshGList  o&, win&, 0, 1
				END IF
			END SELECT
		 	ReplyMsg imsg& 
		ELSE
			EXIT LOOP
		END IF
	LOOP
LOOP
END SUB

